diff --git a/lang/node/Makefile b/lang/node/Makefile
index 2cb81fcb34e..95243fb645e 100644
--- a/lang/node/Makefile
+++ b/lang/node/Makefile
@@ -10,16 +10,11 @@ USE_WXNEEDED =		Yes
 
 COMMENT =		V8 JavaScript for clients and servers
 
-NODE_VERSION =		v8.11.3
-
-PLEDGE_VER =		1.1.0
-DISTFILES =		node-pledge-{}${PLEDGE_VER}.tar.gz:0 ${DISTNAME}.tar.gz
+NODE_VERSION =		v10.9.0
 
 DISTNAME =		node-${NODE_VERSION}
 PKGNAME =		${DISTNAME:S/v//g}
 
-MASTER_SITES0 =		https://github.com/qbit/node-pledge/archive/
-
 CATEGORIES =		lang devel
 
 HOMEPAGE =		http://nodejs.org/
@@ -33,7 +28,7 @@ MASTER_SITES =		${HOMEPAGE}dist/${NODE_VERSION}/
 
 MODULES =		lang/python
 
-WANTLIB += c execinfo kvm m pthread util z ${COMPILER_LIBCXX}
+WANTLIB += c execinfo kvm m pthread util ${COMPILER_LIBCXX}
 
 LIB_DEPENDS =		devel/libexecinfo
 
@@ -49,8 +44,7 @@ CONFIGURE_STYLE =	simple
 
 # libpath and includes aren't picked up, but I added them here as a note.
 # The patch for node.gyp is where they are actually being set.
-CONFIGURE_ARGS =	--prefix=${PREFIX} \
-			--shared-zlib
+CONFIGURE_ARGS =	--prefix=${PREFIX}
 
 .if "${MACHINE_ARCH}" ==	"aarch64"
 CONFIGURE_ARGS +=	--openssl-no-asm
@@ -66,21 +60,6 @@ SUBST_VARS +=		WRKDIST
 MAKE_ENV +=		V=1 CXX="${CXX}" CXXFLAGS="${CXXFLAGS}" \
 			LDFLAGS="-L${LOCALBASE}/lib -L${X11BASE}/lib"
 
-do-extract:
-	mkdir ${WRKSRC}; \
-	tar -C ${WRKDIR} -zxf ${FULLDISTDIR}/${DISTNAME}.tar.gz && \
-	tar -C ${WRKSRC}/deps/npm/node_modules/ -zxf \
-		${FULLDISTDIR}/node-pledge-${PLEDGE_VER}.tar.gz && \
-	mv ${WRKSRC}/deps/npm/node_modules/node-pledge-${PLEDGE_VER} \
-		${WRKSRC}/deps/npm/node_modules/node-pledge
-
-post-extract:
-	# Currently tarbals exclude tools/eslint, while the tests that require it
-	# are still in tree
-	cd ${WRKSRC} && for x in $$(grep -r "tools/eslint" test/* | awk -F: '{print $$1}' | sort | uniq); do \
-		rm $$x; \
-	done
-
 pre-configure:
 	@# Bad practice, but prevents a whole stack of patches.
 	ln -sf ${LOCALBASE}/bin/python${MODPY_VERSION} ${WRKDIR}/bin/python
@@ -92,6 +71,10 @@ pre-configure:
 		${WRKDIST}/common.gypi \
 		${WRKDIST}/tools/test.py
 
+post-configure:
+	sed -i 's/-ldl //' ${WRKSRC}/out/deps/openssl/openssl.target.mk
+	sed -i 's/-ldl //' ${WRKSRC}/out/deps/openssl/openssl-cli.target.mk
+
 post-install:
 	${MODPY_BIN} ${MODPY_LIBDIR}/compileall.py \
 		${PREFIX}/lib/node_modules/npm/node_modules/node-gyp/gyp
diff --git a/lang/node/distinfo b/lang/node/distinfo
index 17480a3a7fe..be8fb067142 100644
--- a/lang/node/distinfo
+++ b/lang/node/distinfo
@@ -1,4 +1,2 @@
-SHA256 (node-pledge-1.1.0.tar.gz) = BuKnrXSkqpTb5Tfap1AHk+l7ucTJLEWbMFNbgQkNBsw=
-SHA256 (node-v8.11.3.tar.gz) = DX55XAV5ImyLGXNTu7k5LK6AL0/vpHh6LA5ni+r4XM4=
-SIZE (node-pledge-1.1.0.tar.gz) = 2560
-SIZE (node-v8.11.3.tar.gz) = 31115954
+SHA256 (node-v10.9.0.tar.gz) = HtMbp1CAsWGT8cejUYB0gbH32gi/r3FyvAfwzwfm6nE=
+SIZE (node-v10.9.0.tar.gz) = 35848393
diff --git a/lang/node/patches/patch-common_gypi b/lang/node/patches/patch-common_gypi
index 682b5771be0..104fb9be516 100644
--- a/lang/node/patches/patch-common_gypi
+++ b/lang/node/patches/patch-common_gypi
@@ -2,7 +2,7 @@ $OpenBSD: patch-common_gypi,v 1.10 2018/06/21 23:13:28 abieber Exp $
 Index: common.gypi
 --- common.gypi.orig
 +++ common.gypi
-@@ -426,6 +426,10 @@
+@@ -503,6 +503,10 @@
          'ldflags': [
            '-Wl,--export-dynamic',
          ],
diff --git a/lang/node/patches/patch-deps_npm_lib_npm_js b/lang/node/patches/patch-deps_npm_lib_npm_js
index 6b0ca10c2a0..b95d4a741b0 100644
--- a/lang/node/patches/patch-deps_npm_lib_npm_js
+++ b/lang/node/patches/patch-deps_npm_lib_npm_js
@@ -2,7 +2,7 @@ $OpenBSD: patch-deps_npm_lib_npm_js,v 1.5 2018/02/10 14:50:35 abieber Exp $
 Index: deps/npm/lib/npm.js
 --- deps/npm/lib/npm.js.orig
 +++ deps/npm/lib/npm.js
-@@ -332,7 +332,7 @@
+@@ -340,7 +340,7 @@
  
          log.resume()
  
diff --git a/lang/node/patches/patch-deps_npm_node_modules_node-gyp_gyp_pylib_gyp_generator_make_py b/lang/node/patches/patch-deps_npm_node_modules_node-gyp_gyp_pylib_gyp_generator_make_py
index 5a4344f0a26..a5cc926f694 100644
--- a/lang/node/patches/patch-deps_npm_node_modules_node-gyp_gyp_pylib_gyp_generator_make_py
+++ b/lang/node/patches/patch-deps_npm_node_modules_node-gyp_gyp_pylib_gyp_generator_make_py
@@ -2,7 +2,7 @@ $OpenBSD: patch-deps_npm_node_modules_node-gyp_gyp_pylib_gyp_generator_make_py,v
 Index: deps/npm/node_modules/node-gyp/gyp/pylib/gyp/generator/make.py
 --- deps/npm/node_modules/node-gyp/gyp/pylib/gyp/generator/make.py.orig
 +++ deps/npm/node_modules/node-gyp/gyp/pylib/gyp/generator/make.py
-@@ -272,6 +272,8 @@ all_deps :=
+@@ -291,6 +291,8 @@ all_deps :=
  
  %(make_global_settings)s
  
diff --git a/lang/node/patches/patch-deps_npm_node_modules_node-gyp_gyp_pylib_gyp_generator_ninja_py b/lang/node/patches/patch-deps_npm_node_modules_node-gyp_gyp_pylib_gyp_generator_ninja_py
index 0a3f5f2996e..da63b6d9d53 100644
--- a/lang/node/patches/patch-deps_npm_node_modules_node-gyp_gyp_pylib_gyp_generator_ninja_py
+++ b/lang/node/patches/patch-deps_npm_node_modules_node-gyp_gyp_pylib_gyp_generator_ninja_py
@@ -2,7 +2,7 @@ $OpenBSD: patch-deps_npm_node_modules_node-gyp_gyp_pylib_gyp_generator_ninja_py,
 Index: deps/npm/node_modules/node-gyp/gyp/pylib/gyp/generator/ninja.py
 --- deps/npm/node_modules/node-gyp/gyp/pylib/gyp/generator/ninja.py.orig
 +++ deps/npm/node_modules/node-gyp/gyp/pylib/gyp/generator/ninja.py
-@@ -2250,7 +2250,7 @@ def GenerateOutputForConfig(target_list, target_dicts,
+@@ -2257,7 +2257,7 @@ def GenerateOutputForConfig(target_list, target_dicts,
      master_ninja.rule(
        'copy',
        description='COPY $in $out',
diff --git a/lang/node/patches/patch-deps_npm_node_modules_node-gyp_lib_build_js b/lang/node/patches/patch-deps_npm_node_modules_node-gyp_lib_build_js
index fe41234d039..f49c6b7023e 100644
--- a/lang/node/patches/patch-deps_npm_node_modules_node-gyp_lib_build_js
+++ b/lang/node/patches/patch-deps_npm_node_modules_node-gyp_lib_build_js
@@ -2,7 +2,7 @@ $OpenBSD: patch-deps_npm_node_modules_node-gyp_lib_build_js,v 1.6 2018/02/10 14:
 Index: deps/npm/node_modules/node-gyp/lib/build.js
 --- deps/npm/node_modules/node-gyp/lib/build.js.orig
 +++ deps/npm/node_modules/node-gyp/lib/build.js
-@@ -220,6 +220,8 @@ function build (gyp, argv, callback) {
+@@ -224,6 +224,8 @@ function build (gyp, argv, callback) {
        }
      } else {
        argv.push('BUILDTYPE=' + buildType)
diff --git a/lang/node/patches/patch-deps_npm_node_modules_node-gyp_lib_install_js b/lang/node/patches/patch-deps_npm_node_modules_node-gyp_lib_install_js
index 0921dbe9f4b..dd9b994b284 100644
--- a/lang/node/patches/patch-deps_npm_node_modules_node-gyp_lib_install_js
+++ b/lang/node/patches/patch-deps_npm_node_modules_node-gyp_lib_install_js
@@ -6,7 +6,7 @@ set, also prevents downloading of the node distfile again.
 Index: deps/npm/node_modules/node-gyp/lib/install.js
 --- deps/npm/node_modules/node-gyp/lib/install.js.orig
 +++ deps/npm/node_modules/node-gyp/lib/install.js
-@@ -141,7 +141,7 @@ function install (gyp, argv, callback) {
+@@ -145,7 +145,7 @@ function install (fs, gyp, argv, callback) {
        }
  
        // now download the node tarball
diff --git a/lang/node/patches/patch-deps_uv_src_unix_openbsd_c b/lang/node/patches/patch-deps_uv_src_unix_openbsd_c
index e862567f455..4bc0191b9df 100644
--- a/lang/node/patches/patch-deps_uv_src_unix_openbsd_c
+++ b/lang/node/patches/patch-deps_uv_src_unix_openbsd_c
@@ -81,7 +81,7 @@ Index: deps/uv/src/unix/openbsd.c
  
 -  if (argsbuf[0] == NULL) {
 +  if (search(argsbuf[0], buffer, size)) {
-     err = -EINVAL;  /* FIXME(bnoordhuis) More appropriate error. */
+     err = UV_EINVAL;  /* FIXME(bnoordhuis) More appropriate error. */
      goto out;
    }
  
diff --git a/lang/node/patches/patch-deps_uv_src_unix_tcp_c b/lang/node/patches/patch-deps_uv_src_unix_tcp_c
index e69de29bb2d..4d88ac03488 100644
--- a/lang/node/patches/patch-deps_uv_src_unix_tcp_c
+++ b/lang/node/patches/patch-deps_uv_src_unix_tcp_c
@@ -0,0 +1,29 @@
+$OpenBSD$
+
+Index: deps/uv/src/unix/tcp.c
+--- deps/uv/src/unix/tcp.c.orig
++++ deps/uv/src/unix/tcp.c
+@@ -183,6 +183,23 @@ int uv__tcp_bind(uv_tcp_t* tcp,
+ #endif
+ #endif
+ 
++#ifdef IPV6_V6ONLY
++  if (addr->sa_family == AF_INET6) {
++    on = (flags & UV_TCP_IPV6ONLY) != 0;
++    if (setsockopt(tcp->io_watcher.fd,
++                   IPPROTO_IPV6,
++                   IPV6_V6ONLY,
++                   &on,
++                   sizeof on) == -1) {
++#if defined(__MVS__)
++      if (errno == EOPNOTSUPP)
++        return -EINVAL;
++#endif
++      return -errno;
++    }
++  }
++#endif
++
+   errno = 0;
+   if (bind(tcp->io_watcher.fd, addr, addrlen) && errno != EADDRINUSE) {
+     if (errno == EAFNOSUPPORT)
diff --git a/lang/node/patches/patch-deps_v8_src_base_cpu_cc b/lang/node/patches/patch-deps_v8_src_base_cpu_cc
index 9bb663cf28d..de9d438a8e6 100644
--- a/lang/node/patches/patch-deps_v8_src_base_cpu_cc
+++ b/lang/node/patches/patch-deps_v8_src_base_cpu_cc
@@ -3,21 +3,21 @@ $OpenBSD: patch-deps_v8_src_base_cpu_cc,v 1.1 2018/02/10 14:50:35 abieber Exp $
 Index: deps/v8/src/base/cpu.cc
 --- deps/v8/src/base/cpu.cc.orig
 +++ deps/v8/src/base/cpu.cc
-@@ -607,6 +607,8 @@ CPU::CPU()
+@@ -424,6 +424,8 @@ CPU::CPU()
  
- #elif V8_HOST_ARCH_ARM64
+ #if V8_OS_LINUX
  
 +#ifdef V8_OS_LINUX
 +
    CPUInfo cpu_info;
  
    // Extract implementor from the "CPU implementer" field.
-@@ -640,6 +642,8 @@ CPU::CPU()
+@@ -457,6 +459,8 @@ CPU::CPU()
      }
      delete[] part;
    }
 +
 +#endif // V8_OS_LINUX
  
- #elif V8_HOST_ARCH_PPC
- 
+   // Extract architecture from the "CPU Architecture" field.
+   // The list is well-known, unlike the the output of
diff --git a/lang/node/patches/patch-deps_v8_src_base_platform_platform-openbsd_cc b/lang/node/patches/patch-deps_v8_src_base_platform_platform-openbsd_cc
index e69de29bb2d..54ab7f50dfb 100644
--- a/lang/node/patches/patch-deps_v8_src_base_platform_platform-openbsd_cc
+++ b/lang/node/patches/patch-deps_v8_src_base_platform_platform-openbsd_cc
@@ -0,0 +1,25 @@
+$OpenBSD$
+
+Index: deps/v8/src/base/platform/platform-openbsd.cc
+--- deps/v8/src/base/platform/platform-openbsd.cc.orig
++++ deps/v8/src/base/platform/platform-openbsd.cc
+@@ -107,7 +107,7 @@ void OS::SignalCodeMovingGC() {
+   // it. This injects a GC marker into the stream of events generated
+   // by the kernel and allows us to synchronize V8 code log and the
+   // kernel log.
+-  int size = sysconf(_SC_PAGESIZE);
++  size_t size = sysconf(_SC_PAGESIZE);
+   FILE* f = fopen(OS::GetGCFakeMMapFile(), "w+");
+   if (f == nullptr) {
+     OS::PrintError("Failed to open %s\n", OS::GetGCFakeMMapFile());
+@@ -115,8 +115,8 @@ void OS::SignalCodeMovingGC() {
+   }
+   void* addr =
+       mmap(NULL, size, PROT_READ | PROT_EXEC, MAP_PRIVATE, fileno(f), 0);
+-  DCHECK(addr != MAP_FAILED);
+-  OS::Free(addr, size);
++  DCHECK_NE(MAP_FAILED, addr);
++  CHECK(Free(addr, size));
+   fclose(f);
+ }
+ 
diff --git a/lang/node/patches/patch-deps_v8_src_base_utils_random-number-generator_cc b/lang/node/patches/patch-deps_v8_src_base_utils_random-number-generator_cc
index e69de29bb2d..1d169d9aab3 100644
--- a/lang/node/patches/patch-deps_v8_src_base_utils_random-number-generator_cc
+++ b/lang/node/patches/patch-deps_v8_src_base_utils_random-number-generator_cc
@@ -0,0 +1,14 @@
+$OpenBSD$
+
+Index: deps/v8/src/base/utils/random-number-generator.cc
+--- deps/v8/src/base/utils/random-number-generator.cc.orig
++++ deps/v8/src/base/utils/random-number-generator.cc
+@@ -50,6 +50,8 @@ RandomNumberGenerator::RandomNumberGenerator() {
+   result = rand_s(&second_half);
+   DCHECK_EQ(0, result);
+   SetSeed((static_cast<int64_t>(first_half) << 32) + second_half);
++#elif V8_OS_OPENBSD
++  SetSeed(arc4random());
+ #else
+   // Gather entropy from /dev/urandom if available.
+   FILE* fp = fopen("/dev/urandom", "rb");
diff --git a/lang/node/patches/patch-deps_v8_src_log-utils_h b/lang/node/patches/patch-deps_v8_src_log-utils_h
index e69de29bb2d..9ac88c3b002 100644
--- a/lang/node/patches/patch-deps_v8_src_log-utils_h
+++ b/lang/node/patches/patch-deps_v8_src_log-utils_h
@@ -0,0 +1,14 @@
+$OpenBSD$
+
+Index: deps/v8/src/log-utils.h
+--- deps/v8/src/log-utils.h.orig
++++ deps/v8/src/log-utils.h
+@@ -15,6 +15,8 @@
+ #include "src/flags.h"
+ #include "src/ostreams.h"
+ 
++#include <stdarg.h>
++
+ namespace v8 {
+ namespace internal {
+ 
diff --git a/lang/node/patches/patch-lib_internal_modules_cjs_loader_js b/lang/node/patches/patch-lib_internal_modules_cjs_loader_js
index e69de29bb2d..de500ed59b3 100644
--- a/lang/node/patches/patch-lib_internal_modules_cjs_loader_js
+++ b/lang/node/patches/patch-lib_internal_modules_cjs_loader_js
@@ -0,0 +1,17 @@
+$OpenBSD$
+
+Index: lib/internal/modules/cjs/loader.js
+--- lib/internal/modules/cjs/loader.js.orig
++++ lib/internal/modules/cjs/loader.js
+@@ -767,7 +767,10 @@ Module._initPaths = function() {
+   } else {
+     prefixDir = path.resolve(process.execPath, '..', '..');
+   }
+-  var paths = [path.resolve(prefixDir, 'lib', 'node')];
++  var paths = [
++    path.resolve(prefixDir, 'lib', 'node'),
++    path.resolve(prefixDir, 'lib', 'node_modules'),
++  ];
+ 
+   if (homeDir) {
+     paths.unshift(path.resolve(homeDir, '.node_libraries'));
diff --git a/lang/node/patches/patch-node_gypi b/lang/node/patches/patch-node_gypi
index 2738d5f6eb9..57855165138 100644
--- a/lang/node/patches/patch-node_gypi
+++ b/lang/node/patches/patch-node_gypi
@@ -3,7 +3,7 @@ $OpenBSD: patch-node_gypi,v 1.3 2018/06/21 23:13:28 abieber Exp $
 Index: node.gypi
 --- node.gypi.orig
 +++ node.gypi
-@@ -137,11 +137,14 @@
+@@ -212,11 +212,14 @@
          'NODE_PLATFORM="darwin"',
        ],
      }],
diff --git a/lang/node/patches/patch-tools_icu_icu-generic_gyp b/lang/node/patches/patch-tools_icu_icu-generic_gyp
index 57a70f0301a..505082675ff 100644
--- a/lang/node/patches/patch-tools_icu_icu-generic_gyp
+++ b/lang/node/patches/patch-tools_icu_icu-generic_gyp
@@ -2,7 +2,7 @@ $OpenBSD: patch-tools_icu_icu-generic_gyp,v 1.3 2018/06/21 23:13:28 abieber Exp
 Index: tools/icu/icu-generic.gyp
 --- tools/icu/icu-generic.gyp.orig
 +++ tools/icu/icu-generic.gyp
-@@ -549,6 +549,7 @@
+@@ -547,6 +547,7 @@
        'toolsets': [ 'host' ],
        'type': 'executable',
        'dependencies': [ 'icutools' ],
diff --git a/lang/node/patches/patch-tools_test_py b/lang/node/patches/patch-tools_test_py
index 05958084b76..0f89f1db6d3 100644
--- a/lang/node/patches/patch-tools_test_py
+++ b/lang/node/patches/patch-tools_test_py
@@ -2,7 +2,7 @@ $OpenBSD: patch-tools_test_py,v 1.4 2018/02/10 14:50:35 abieber Exp $
 Index: tools/test.py
 --- tools/test.py.orig
 +++ tools/test.py
-@@ -905,9 +905,9 @@ class Context(object):
+@@ -894,9 +894,9 @@ class Context(object):
  
    def GetVm(self, arch, mode):
      if arch == 'none':
